#### connect (1 of 12 overloads)

Establishes a socket connection by trying each endpoint in a sequence.

    template<
        typename Protocol,
        typename Executor,
        typename EndpointSequence>
    Protocol::endpoint connect(
        basic_socket< Protocol, Executor > & s,
        const EndpointSequence & endpoints,
        typename enable_if< is_endpoint_sequence< EndpointSequence >::value >::type *  = 0);

This function attempts to connect a socket to one of a sequence of endpoints. It does this by repeated calls to the socket's `connect` member function, once for each endpoint in the sequence, until a connection is successfully established.

###### Parameters

s

  The socket to be connected. If the socket is already open, it will be closed.

endpoints

  A sequence of endpoints.

###### Return Value

The successfully connected endpoint.

###### Exceptions

asio::system_error

  Thrown on failure. If the sequence is empty, the associated `error_code` is `asio::error::not_found`. Otherwise, contains the error from the last connection attempt.

###### Example

    tcp::resolver r(my_context);
    tcp::resolver::query q("host", "service");
    tcp::socket s(my_context);
    asio::connect(s, r.resolve(q));